#include <stdio.h>

const char *szInput = "NUMBERS.DAT";
const char *szOutput = "NUMBERS.SOL";

#define MAX_LONG			22
#define MAX_NUMB_RES		1701

typedef unsigned __int64 uint64;
typedef unsigned int uint;
typedef unsigned char uint8;

typedef uint8 * uintLong;
uint XSum, YSum;
uintLong X, Y;

uint sqr(uint n) { return n*n; }

void ReadLong(uintLong Numb, FILE *fIn)
{
	char c; uint N = 1;
	do
	{
		fread(&c, sizeof(char), 1, fIn);
		Numb[N] = c - '0';
		N++;
	} while ((!feof(fIn))&&(c != '\n'));
	Numb[0] = N - 2;
}

bool IsEquale(uintLong A, uintLong B)
{
	if (A[0] != B[0]) return false;
	for (uint8 i = 0; i < A[0]; i++)
		if (A[i + 1] != B[i + 1]) return false;
	return true;
}

bool IsASmaller(uintLong A, uintLong B)
{
	if (A[0] > B[0]) return false;
	if (A[0] == B[0])
	{
		for (uint8 i = 0; i < A[0]; i++)
			if (A[i + 1] > B[i + 1]) return false;
			else if (A[i + 1] < B[i + 1]) return true;
	}
	return true;
}

uintLong LongNumbPlus(uintLong A) //+1
{
	bool bAddStage = false; // 
	for (uint8 i = A[0]; ((i > 0)||(!bAddStage))&&(i != 0); i--)
	{
		if (A[i] == 9)
		{
			A[i] = 0;
			bAddStage = true;
			if (i == 1)
			{
				uintLong buf = new uint8[MAX_LONG];
				for (uint8 j = 0; j < A[0]; j++)
				{
					buf[j + 2] = A[j + 1];
				}
				buf[1] = 1;
				buf[0] = A[0] + 1;
				//delete []A;
				A = buf;
				bAddStage = false;
				break;
			}
		}
		else
		{
			A[i]++;
			bAddStage = false;
			break;
		}
	}
	return A;
}

void fprintfLong(uintLong A, FILE *fOut)
{
	for (uint8 i = 0; i < A[0]; i++)
		fprintf(fOut, "%i", A[i + 1]);
	fprintf(fOut, "\n");
}

uint CalcLen(uintLong A, uintLong C)
{
	if (IsEquale(A, C)) return 0;

	uint8 iLenMinus, uNumb = 0;
	if (C[0] > A[0])
	{
		iLenMinus = C[0] - A[0];

		for (uint i = 0; i < iLenMinus; i++)
			uNumb += sqr(C[i + 1]);

		for (uint i = 0; i < A[0]; i++)
			uNumb += sqr(A[i + 1] - C[i + iLenMinus + 1]);
	}
	else
	{
		iLenMinus = A[0] - C[0];

		for (uint i = 0; i < iLenMinus; i++)
			uNumb += sqr(A[i + 1]);

		for (uint i = 0; i < C[0]; i++)
			uNumb += sqr(C[i + 1] - A[i + iLenMinus + 1]);
	}

	return uNumb;
}

uintLong CopyStr(uintLong A)
{
	uintLong buf = new uint8[MAX_LONG];
	buf[0] = A[0];
	for (uint8 i = 0; i < A[0]; i++)
		buf[i + 1] = A[i + 1];
	return buf;
}

uintLong LongMinus10(uintLong A)
{
	bool bEmpty = true;
	for (uint8 i = 0; i < A[0]; i++)
		if (A[i + 1] != 0) bEmpty = false;
	if (bEmpty)
	{
		A[0] = 0;
		return A;
	}

	if (A[A[0] - 1] == 0)
	{
		for (uint8 j = A[0] - 1; j > 0 ; j--)
			if (A[j] != 0)
			{
				A[j]--;
				for (uint8 i = j + 1; i < A[0]; i++) A[i] = 9;
				A[A[0]] = 0;

				if (A[1] == 0)
				{
					uintLong buf = new uint8[MAX_LONG];
					for (uint8 i = 0; i < A[0]; i++)
					{
						buf[i + 1] = A[i + 2];
					}
					buf[0] = A[0] - 1;
					delete []A;
					A = buf;
				}
				break;
			}
	}
	else A[A[0] - 1]--;
	return A;
}

uintLong LongPlus10(uintLong A)
{
	if (A[0] == 1)
	{
		A[0] = 2;
		A[2] = A[1];
		A[1] = 1;
	}
	else
	{
		if (A[A[0] - 1] == 9)
		{
			for (uint8 i = A[0] - 1; i > 0 ; i--)
			{
				if (A[i] < 9) break;

				A[i]++;
				if (A[i] > 9)
				{
					A[i] -= 10;
					if (i > 1) A[i - 1]++;
					else
					{
						A[0]++;
						for (uint8 j = A[0]; j > 1; j--)
							A[j] = A[j - 1];
						A[1] = 1;
						break;
					}
				}
			}
		} else A[A[0] - 1]++;
	}
	return A;
}

void FindVals(uintLong A, uintLong B, uintLong C, FILE *fOut)
{
	if (IsEquale(A, B))
	{
		X = A;
		Y = A;
		return;
	}

	X = new uint8[MAX_LONG]; X[0] = 0;
	Y = new uint8[MAX_LONG]; Y = CopyStr(A);
	XSum = MAX_NUMB_RES;
	YSum = 0;
	uint buf;

	A[A[0]] = 9;
	for (uint i = 1; i < A[0]; i++) A[i] = 1;
	while (IsASmaller(A, B))
	{
		buf = CalcLen(A, C);
		if (buf > YSum)
		{
			YSum = buf;
			delete []Y;
			Y = CopyStr(A);
		}
		A = LongPlus10(A);
	}

	if (B[0] == 1)
	{
		delete []X;
		X = CopyStr(B);
	}
	else
	{
		B[B[0]] = 0;

		while (B[1] != 0)
		{
			buf = CalcLen(B, C);
			if (buf < XSum)
			{
				XSum = buf;
				delete []X;
				X = CopyStr(B);
			}

			//fprintfLong(B, fOut);
			//fprintf(fOut, "XS: %i\n", XSum);
			if (XSum == 1) break;
			B = LongMinus10(B);
		}
	}
}

int main()
{
	FILE *fIn = fopen(szInput, "rt");
	uintLong A, B, C;
	A = new uint8[MAX_LONG];
	ReadLong(A, fIn);

	B = new uint8[MAX_LONG];
	ReadLong(B, fIn);

	C = new uint8[MAX_LONG];
	ReadLong(C, fIn);
	fclose(fIn);

	//End -- result is writing
	FILE *fOut = fopen(szOutput, "wt");
	FindVals(A, B, C, fOut);
	//fprintf(fOut, "%i %i\n", XSum, YSum);
	fprintfLong(X, fOut);
	fprintfLong(Y, fOut);
	fclose(fOut);
	return 0;
}