#include <stdio.h>
#include <math.h>

const char *szInput = "PAIRS.DAT";
const char *szOutput = "PAIRS.SOL";

typedef unsigned __int64 uint64;
typedef unsigned int uint;
typedef unsigned short int uint16;
typedef short int int16;

struct Point
{
	int16 X;
	int16 Y;
	uint16 Index;
};

struct Vektor
{
	Point First, Second;
	int A;
	int B;
	int C;
};

const uint MaxVektors = 2500;
uint16 N, Blocks;
Vektor *Vektors;
Point Red[MaxVektors];
Point Result[MaxVektors];
bool bUsedRed[MaxVektors];
bool bUsedBlue[MaxVektors];

Vektor GetVektor(Point First, Point Second)
{
	Vektor vek;
	vek.First = First;
	vek.Second = Second;

	vek.A = Second.Y - First.Y;
	vek.B = First.X - Second.X;
	vek.C = Second.X * First.Y - First.X * Second.Y;
	return vek;
}

int GetVektorVal(Vektor vek, Point pt)
{
	return (vek.A * pt.X + vek.B * pt.Y + vek.C);
}

bool DividingPointExists(Vektor First, Vektor Second)
{
	int x = (First.B * Second.C - First.C * Second.B) / (Second.B * First.A - First.B * Second.A);
	int y = (0 - Second.A * x - Second.C) / Second.B;
	if ((abs(x) <= abs(Second.First.X - Second.Second.X))&&
		(abs(y) <= abs(Second.First.Y - Second.Second.Y))) return true;
	return false;
}

bool IsNotDivides(Vektor First, Vektor Second)
{
	if ((((Second.First.Y < GetVektorVal(First, Second.First))&&
		(Second.Second.Y > GetVektorVal(Second, Second.Second)))||
		((Second.First.Y > GetVektorVal(First, Second.First))&&
		(Second.Second.Y < GetVektorVal(Second, Second.Second))))&&
		//  +/- 
		(!DividingPointExists(First, Second))) return true;
	return false;
}

int main()
{
	FILE *fIn = fopen(szInput, "rt");
	fscanf(fIn, "%u", &Blocks);
	FILE *fOut = fopen(szOutput, "wt");
	Vektors = new Vektor[MaxVektors * MaxVektors];
	for (uint16 i = 0; i < Blocks; i++)
	{
		uint FoundCount = 0;
		fscanf(fIn, "%u", &N);
		for (uint16 j = 0; j < N; j++)
		{
			fscanf(fIn, "%u %u", &Red[j].X, &Red[j].Y);
			Red[j].Index = j;
		}

		uint vCount = 0;
		for (uint16 j = 0; j < N; j++)
		{
			bUsedRed[j] = false;
			bUsedBlue[j] = false;
			Point pt;
			fscanf(fIn, "%u %u", &pt.X, &pt.Y);
			pt.Index = j;
			for (uint16 m = 0; m < N; m++)
				Vektors[vCount + m] = GetVektor(pt, Red[m]);
			vCount += N;
		}

		for (uint16 j = 0; j < vCount; j++)
		{
			bool bFound = true;
			if ((bUsedRed[Vektors[j].First.Index])||(bUsedBlue[Vektors[j].Second.Index])) continue;
			for (uint16 m = 0; m < j; m++)
			{
				if ((m != j)&&(IsNotDivides(Vektors[j], Vektors[m])))
				{
					bFound = false;
					break;
				}
			}

			if (bFound)
			{
				Result[FoundCount].X = Vektors[j].First.Index;
				Result[FoundCount].Y = Vektors[j].Second.Index;
				bUsedRed[Vektors[j].First.Index] = true;
				bUsedBlue[Vektors[j].Second.Index] = true;
				FoundCount++; if (FoundCount == N) break;
			}
		}

		if (FoundCount == N)
		{
			for (uint j = 0; j < FoundCount; j++)
				fprintf(fOut, "%u %u\n", Result[j].X + 1, Result[j].Y + 1);
		} else fprintf(fOut, "0\n");
	}
	fclose(fOut);
	fclose(fIn);
	return 0;
}