#include <fstream>

using namespace std;
ifstream fin("pairs.dat");
ofstream fout("pairs.sol");
const int MNAX=2500;

void Swap(int &x,int &y){
	int k=x;x=y;y=k;
}
void Qsort(int* a,int* b,int* c,int first,int last){
	int left = first,right = last;
	int v = a[(left+right)/2];
	while (left<=right){
		while (a[left]<v){++left;}
		while (a[right]>v){--right;}
		if (left<=right){
			Swap(a[left],a[right]);
			Swap(b[left],b[right]);
			Swap(c[left],c[right]);
			++left;--right;
		}
	}
	if (first<right){Qsort(a,b,c,first,right);}
	if (left<last){Qsort(a,b,c,left,last);}
}

bool Intersect(int x1,int y1,int x2,int y2,int x3,int y3,int x4,int y4){
	bool bl1=false,bl2=false;
	if (x1==x2){
		if ((x3<=x1 && x4>=x1)||(x3>=x1 && x4<=x1)){
			bl1 = true;
		}
	}
	else{
		if (((y1-y2)*(x3-x1)/double(x1-x2)+y1)*((y1-y2)*(x4-x1)/double(x1-x2)+y1)<=0) bl1=true;
	}

	if (x3==x4){
		if ((x1<=x3 && x2>=x3)||(x1>=x3 && x2<=x3)){
			bl2 = true;
		}
	}
	else{
		if (((y3-y4)*(x1-x3)/double(x3-x4)+y3)*((y3-y4)*(x2-x3)/double(x3-x4)+y3)<=0) bl2=true;
	}

	if (bl1==true && bl2==true) return true;
	return false;
}

int x1[MNAX+2],y1[MNAX+2];
int x2[MNAX+2],y2[MNAX+2];
int ans[MNAX+2];
int ind1[MNAX+2],ind2[MNAX+2];
int main(){
	int test,t;
	fin>>test;
	for (t=1;t<=test;++t){
		int n,i,j;
		fin>>n;
		for (i=1;i<=n;++i) fin>>x1[i]>>y1[i];
		for (i=1;i<=n;++i) fin>>x2[i]>>y2[i];
		for (i=1;i<=n;++i) ind1[i]=i;
		for (i=1;i<=n;++i) ind2[i]=i;
		Qsort(x1,y1,ind1,1,n);
		Qsort(x2,y2,ind2,1,n);
		for (i=1;i<=n;++i) ans[ind1[i]]=ind2[i];
		
		int kol = 0;

		bool bl;

		int kk;
		if (n<=10) kk = n*n;
		else if (n<=200) kk = n;
		else kk = n/10;

		while (kol<=kk){
			bl=true;
			for (i=1;i<=n;++i){
				for (j=i+1;j<=n;++j){
					if (Intersect(x1[i],y1[i],x2[ans[i]],y2[ans[i]],x1[j],y1[j],x2[ans[j]],y2[ans[j]])==true){
						Swap(ans[i],ans[j]);
						bl=false;
					}
				}
			}
			if (bl==true) break;
			++kol;
		}
		if (bl==false){
			fout<<"0\n";
		}
		else{
			for (i=1;i<=n;++i){
				fout<<i<<' '<<ans[i]<<'\n';
			}
		}
	}
	return 0;
}