#include <iostream>
using namespace std;
int ax[3000], ay[3000], az[3000];
int bx[3000], by[3000], bz[3000];

inline bool intersect(int i, int j){
	double a1=ay[i]-by[i];
	double a2=ay[j]-by[j];
	double b1=bx[i]-ax[i];
	double b2=bx[j]-ax[j];
	double c1=ax[i]*by[i]-bx[i]*ay[i];
	double c2=ax[j]*by[j]-bx[j]*ay[j];
	bool z=((a1*ax[j]+b1*ay[j]+c1)*(a1*bx[j]+b1*by[j]+c1)<=0);
	z=z && ((a2*ax[i]+b2*ay[i]+c2)*(a2*bx[i]+b2*by[i]+c2)<=0);
	return z;
}

void swapA (int i, int j){
	int x=ax[i];
	ax[i]=ax[j];
	ax[j]=x;
	x=ay[i];
	ay[i]=ay[j];
	ay[j]=x;
	x=az[i];
	az[i]=az[j];
	az[j]=x;
}

void swapB (int i, int j){
	int x=bx[i];
	bx[i]=bx[j];
	bx[j]=x;
	x=by[i];
	by[i]=by[j];
	by[j]=x;
	x=bz[i];
	bz[i]=bz[j];
	bz[j]=x;
}

void sortA (int be, int en){
	int k=be-1;
	int m=en+1;
	int i=(be+en)/2;
	int yy=ay[i];
	int xx=ax[i];
	i=be;
	while (i<m)
		if (ay[i]<yy || (ay[i]==yy && ax[i]>xx)) swapA (++k, i++);
		else if (ay[i]>yy || (ay[i]==yy && ax[i]<xx)) swapA (--m, i);
			else i++;
	if (be<k) sortA (be, k);
	if (m<en) sortA (m, en);
}

void sortB (int be, int en){
	int k=be-1;
	int m=en+1;
	int i=(be+en)/2;
	int yy=by[i];
	int xx=bx[i];
	i=be;
	while (i<m)
		if (by[i]<yy || (by[i]==yy && bx[i]<xx)) swapB (++k, i++);
			else if (by[i]>yy || (by[i]==yy && bx[i]>xx)) swapB (--m, i);
				else i++;
	if (be<k) sortB (be, k);
	if (m<en) sortB (m, en);
}

void solve(){
	int n;
	scanf ("%d",&n);
	for (int t=0; t<n; t++)
		scanf ("%d%d",&ax[t], &ay[t]), az[t]=t+1;
	for (int t=0; t<n; t++)
		scanf ("%d%d",&bx[t], &by[t]), bz[t]=t+1;
	sortA (0, n-1);
	sortB (0, n-1);
	
	bool z=n==1 || !intersect (0,1);
	for (int t=2; z && t<n; t++)
		z=z && !(intersect(t, t-1) || intersect(t,t-2));
	if (z)
		for (int t=0; t<n; t++)
			printf ("%d %d\n",az[t],bz[t]);
	else printf ("0\n");
}

int main(){
	freopen ("PAIRS.DAT","r",stdin);
	freopen ("PAIRS.SOL","w",stdout);
	int g;
	scanf ("%d",&g);
	for (int t=0; t<g; t++)
		solve ();
	return 0;
}