#include <cstdio>
#include <cmath>
#include <cstring>
using namespace std;

const int NMax = 3000;
const double eps = 0.00001;

int bluex[NMax];
int bluey[NMax];
int redx[NMax];
int redy[NMax];

int solb[NMax];
int solr[NMax];
int solp = 0;
int dotscnt;
bool wasb[NMax];
bool wasr[NMax];

bool found;

void Solve(int blue);
bool Cross(int x1, int y1, int x2, int y2, int x3, int y3, int x4, int y4);

int main()
{
	const char *InFile = "PAIRS.DAT";
	const char *OutFile = "PAIRS.SOL";
	
	int cnt_test, index_test;
	
	int i;
	
	freopen(InFile, "rt", stdin);
	freopen(OutFile, "wt", stdout);

	scanf("%d", &cnt_test);
	for (index_test=0; index_test<cnt_test; index_test++) {
		memset(wasb, 0, sizeof(wasb));
		memset(wasr, 0, sizeof(wasr));
		found = false;
		solp = 0;
		scanf("%d", &dotscnt);
		for (i=0; i<dotscnt; i++) {
			scanf("%d%d", &bluex[i], &bluey[i]);
		}
		for (i=0; i<dotscnt; i++) {
			scanf("%d%d", &redx[i], &redy[i]);
		}
		Solve(0);
		for (i=1; i<=solp; i++) {
			printf("%d %d\n", solb[i]+1, solr[i]+1);
		}
		if (!solp)
			printf("0\n");
	}

	fclose(stdin);
	fclose(stdout);
	
	return 0;
}

void Solve(int blue)
{
	if (wasb[blue])
		return;
	if (blue >= dotscnt) {
		found = true;
	}
	int i;
	for (i=0; i<dotscnt; i++) {
		if (wasr[i])
			continue;
		int j;
		bool cannot = false;
		for (j=0; j<solp; j++) {
			if (Cross(bluex[blue], bluey[blue], redx[i], redy[i], bluex[solb[i]], bluey[solb[i]], redx[solr[i]], redy[solr[i]])) {
				cannot = true;
				break;
			}
		}
		if (!cannot) {
			solp++;
			solb[solp] = blue;
			solr[solp] = i;
			wasb[blue] = true;
			wasr[i] = true;
			Solve(blue+1);
			if (found)
				return;
			wasb[blue] = false;
			wasr[i] = false;
			solp--;
		}
	}
}

bool CrossLine(int a1, int b1, int c1, int a2, int b2, int c2, double &x, double &y)
{
	double tx = a1*b2 - a2*b1;
	double ty = b1*a2 - b2*a1;
	if (abs(tx)<eps || abs(ty)<eps)
		return false;
	x = (c2*b1 - c1*b2) / tx;
	y = (c2*a1 - c1*a2) / ty;
	return true;
}

bool Cross(int x1, int y1, int x2, int y2, int x3, int y3, int x4, int y4)
{
	int a1, b1, c1, a2, b2, c2;
	a1 = y1-y2;
	b1 = x2-x1;
	a2 = y3-y4;
	b2 = x4-x3;
	c1 = -(a1*x1 + b1*y1);
	c2 = -(a2*x3 + b2*y3);
	double x, y;
	if (!CrossLine(a1, b1, c1, a2, b2, c2, x, y))
		return false;
	/*if (!((x2-x1)*(y4-y3)-(y2-y1)*(x4-x3))) {
		if (abs((x2-x3)*(y3-y1))==abs((x3-x1)*(y2-y3)))
			return true;
		if (abs((x4-x1)*(y1-y3))==abs((x1-x3)*(y4-y1)))
			return true;
		return false;
	}*/
	return (((x1<x && x<x2) || (x2<x && x<x1))  &&  ((y1<y && y<y2) || (y2<y && y<y1)));
}
