#include <fstream>
#include <vector>
#include <cmath>
using namespace std;
struct pt{int x,y;};
struct det{int i,j;};
vector<bool> flaga,flagb;
vector<pt> a,b;
vector<det> c;
int k;
#ifndef sqr
double sqr(double x){return x*x;}
#endif
double dist(double x0,double y0,double x1,double y1)
{
	return sqrt(sqr(x0-x1)+sqr(y0-y1));
}
bool check(int i,int j)
{
	int k;
	for(k=0;k<c.size();k++)
	{
		if(i==c[k].i && j==c[k].j)continue;
		double A1=b[c[k].j].y-a[c[k].i].y,B1=a[c[k].i].x-b[c[k].j].x,C1=-A1*a[c[k].i].x-B1*a[c[k].i].y;
		double A2=b[i].y-a[i].y,B2=a[i].x-b[j].x,C2=-A2*a[i].x-B2*a[i].y;
		double d=A1*B2-B1*A2;
		if(d==0)continue;
		double dx=C1*B2-C2*B1,dy=A1*C2-A2*C1;
		double xp=-dx/d,yp=-dy/d;
		double x1=a[c[k].i].x,x2=b[c[k].j].x,y1=a[c[k].i].y,y2=b[c[k].j].y;
		double x3=a[i].x,y3=a[i].y,x4=a[i].y,y4=a[i].y;
		if(abs(dist(xp,yp,x1,y1)+dist(xp,yp,x2,y2)-dist(x1,y1,x2,y2))<=1e-5)return false;
		if(abs(dist(xp,yp,x3,y3)+dist(xp,yp,x4,y4)-dist(x3,y3,x4,y4))<=1e-5)return false;
	}
	return true;
}
bool recurse()
{
    int i,j;
    bool nflag=true;
    if(c.size()==a.size())return true;
    for(i=0;i<a.size();i++)
        for(j=0;j<b.size();j++)
        if(!(flaga[i]) && !(flagb[j]))
		if(check(i,j))
        {
            det aa;aa.i=i;aa.j=j;
            c.push_back(aa);
            nflag=false;
            flaga[i]=true;
            flagb[j]=true;
            if(recurse())return true;
            flaga[i]=false;
            flagb[j]=false;
            c.pop_back();
        }
    return false;
}
int main()
{
    ifstream in("pairs.dat");
    int t,ti,i;in>>t;
    ofstream out("pairs.sol");
    for(ti=0;ti<t;ti++)
    {
        int n;in>>n;
        a.resize(n);
        b.resize(n);
        for(i=0;i<n;i++)in>>a[i].x>>a[i].y;
        for(i=0;i<n;i++)in>>b[i].x>>b[i].y;
        flaga.clear();
        flaga.resize(n,false);
        flagb.clear();
        flagb.resize(n,false);
        k=0;
        c.clear();
//        c.resize(n);
        if(!recurse())out<<"0\n";else
        for(i=0;i<n;i++)out<<c[i].i+1<<' '<<c[i].j+1<<'\n';
    }
    in.close();
    out.close();
    return 0;
}
