#include <cstdio>
#include <iostream>
#include <algorithm>

#define MAX 2500

using namespace std;

struct point {
  int x,y,name;
};

struct line {
  int a,b,c;

  inline void build(const point &A,const point &B) {
    a=B.y-A.y;
	b=A.x-B.y;
	c=A.y*B.x-A.x*B.y;
  }

  inline int f(const point &P) {
	  return (a*P.x+b*P.y+c>0)?1:-1;
  }
};

inline int comp(const point &a,const point &b) {
  return (a.x<b.x || (a.x==b.x && a.y<b.y));
}

line k,l;

inline bool cross(const point &A,const point &B,const point &C,const point &D) {
  k.build(A,B); l.build(C,D);

  return (k.f(C)*k.f(D)==-1) && (l.f(A)*l.f(B)==-1);
}

int Blocks,n;
point Red[MAX],Blue[MAX];
int Pair[MAX];
unsigned long long fact;

inline void read() {
  scanf("%d",&n);
  for (int i=0;i<n;i++) scanf("%d%d",&Blue[i].x,&Blue[i].y);
  for (int i=0;i<n;i++) scanf("%d%d",&Red[i].x,&Red[i].y);
}

inline void brute() {
  fact=1;
  for (int i=2;i<n;i++) fact*=i;

  for (int i=0;i<n;i++) Pair[i]=i;
  bool found=true;
	
  for (int i=0;i<n-1;i++)
	for (int j=i+1;j<n;j++)
	  if (cross(Red[i],Blue[Pair[i]],Red[j],Blue[Pair[j]])) {
	    found=false; break;
	  }

  while (!found && fact) {
	fact--;
    next_permutation(Pair,Pair+n);

	found=true;
	
    for (int i=0;i<n-1;i++)
	  for (int j=i+1;j<n;j++)
		  if (cross(Red[i],Blue[Pair[i]],Red[j],Blue[Pair[j]])) {
			  found=false; break;
		  }
  }

  if (!found) {
    cout<<0<<endl;
  } else {
    for (int i=0;i<n;i++) printf("%d %d\n",Pair[i]+1,i+1);
  }
}

inline void clever() {
  for (int i=0;i<n;i++) Blue[i].name=i+1;
  for (int i=0;i<n;i++) Red[i].name=i+1;
  sort(Blue,Blue+n,comp);
  sort(Red,Red+n,comp);
  for (int i=0;i<n;i++) 
    printf("%d %d\n",Blue[i].name,Red[i].name);
}

int main() {
  freopen("pairs.dat","r",stdin);
  freopen("pairs.sol","w",stdout);

  scanf("%d",&Blocks);
  for (int b=0;b<Blocks;b++) {
    read(); if (n<11) brute(); else clever();
  }

  return 0;
}