#include <fstream>
#include <math.h>

using namespace std;

struct Point
{
	int x,y;
};

float Length(Point a,Point b)
{
	return sqrt((float)(a.x - b.x)*(a.x - b.x) + (float)(a.y - b.y)*(a.y - b.y));
}

int n,c = 0;

void MakeVO(Point in[],Point out[],int num)
{
	int m,next,cur;

	float dx,dy;

	m = 0;
	for (int i = 0;i<num;i++)
		if (in[i].y < in[m].y || (in[i].y == in[m].y && in[i].x < in[m].x)) m = i;
	cur = m;
	out[c++] = in[m];

	dx = -1;
	dy = 0;

	do
	{
		float mcos,bestcos = -2,len,bestlen = -INT_MAX,dp;

		next = 0;

		for (int i = 0;i<num;i++)
		{
			len = Length(in[i],in[cur]);
			if (len == 0) continue;

			dp = dx*(in[i].y - in[cur].y) - dy*(in[i].x - in[cur].x);
			mcos = dp/len;

			if (mcos > bestcos || (mcos == bestcos && len > bestlen)) 
			{
				bestcos = mcos;
				bestlen = len;
				next = i;
			}
		}

		if (next == 0) return;

		dx = (in[next].x - in[cur].x)/bestlen;
		dy = (in[next].y - in[cur].y)/bestlen; 

		out[c++] = in[next];

		cur = next;

	} while (cur != m);
}

int anum = 0;
Point a[5000],o[5000],g[2500],b[2500],answ[5000];

bool Comp(Point a,Point b)
{
	if (a.x == b.x && a.y == b.y) return true; else return false;
}


bool NotChecked(Point a)
{
	bool t = true;
	for (int i = 0;i<anum;i++) if (Comp(a,answ[i])) { t = false; break;}
	return t;
}

int Concat(Point a[],Point b[],Point out[], int len)
{
	int count = 0;
	bool t = false;
	for (int i = 0;i<len;i++)
	{
		if (!t)
		{
			if (NotChecked(a[i]))
			{
				out[count++] = a[i];
				if (i >= n - 1) t = true;
			}
		}
		else
		{
			if (NotChecked(b[i - len/2])) out[count++] = b[i - len/2];
		}
	}

	return count;
}

int BNum = 0;

Point out[5000];
int outnum;

bool Check(Point a,Point b)
{
	int e = 0,r = 0;
	for (int i = 0;i<n;i++)
	{
		if (Comp(g[i],a)) e = 1;
		if (Comp(g[i],b)) r = 1;
	}

	if (e + r == 1) return true; else return false;
}

int FindMinimal(Point in,Point out[])
{
	float Min = INT_MAX;
	int mAnsw;
	for (int i = 0;i<n;i++)
	{
		float t = Length(in,out[i]);
		if (t < Min) 
		{
			Min = t;
			mAnsw = i;
		}
	}

	return mAnsw;
}

Point GetIndex(Point a1,Point b1)
{
	Point tmp;
	for (int i = 0;i<n;i++)
	{
		if (Comp(g[i],a1) || Comp(g[i],b1)) tmp.x = i;
	}

	for (int i = 0;i<n;i++)
	{
		if (Comp(b[i],a1) || Comp(b[i],b1)) tmp.y = i;
	}

	return tmp;
}

int main()
{
	ifstream inf("pairs.dat");
	ofstream outf("pairs.sol");

	inf >> BNum;
	for (int j = 0;j<BNum;j++)
	{
		inf >> n; c = 0; anum = 0; 
		for (int i = 0;i<n;i++) inf >> g[i].x >> g[i].y;
		for (int i = 0;i<n;i++) inf >> b[i].x >> b[i].y;
		
		while(anum < 2*n)
		{
  			int oldanum = anum;
			c = 0;
			int con = Concat(g,b,a,2*n);
			MakeVO(a,o,con);
			
			bool po = false;
			for (int i = 0;i<c-1;i+=2)
			{
				if (Check(o[i],o[i+1]))
				{
					answ[anum++] = o[i];
					answ[anum++] = o[i+1];
					if (i == 0) po = true;
				}
			}
			if (Check(o[c-1],o[0]) && !po)
			{
				answ[anum++] = o[c-1];
				answ[anum++] = o[0];
			}

			if (anum == oldanum)
			{
				outnum = 0;
				if (!Check(o[0],g[0]))
				{
					for (int i = 0;i<n;i++)
					{
						bool t = false;
						for (int k = 0;k<anum;k++) if (Comp(answ[k],b[i])) { t = true; break;}
						if (!t) out[outnum++] = b[i];
					}

				}
				else			
				{
					for (int i = 0;i<n;i++)
					{
						bool t = false;
						for (int k = 0;k<anum;k++) if (Comp(answ[k],g[i])) { t = true; break;}
						if (!t) out[outnum++] = g[i];
					}

				}

				for (int i = 0;i<c;i++) 
				{
					int y = FindMinimal(o[i],out);
					answ[anum++] = o[i];
					answ[anum++] = out[y];
				}
			}
		}	
		

		for (int i = 0;i<anum;i+=2)
		{
			Point tmp = GetIndex(answ[i],answ[i+1]);
			outf << tmp.x + 1 << " " << tmp.y + 1 << endl;
		}
		
	}

	inf.close();
	outf.close();
}