program PAIRS;

{$APPTYPE CONSOLE}

type
  TPoint = record
    X, Y: Extended;
  end;
  TConection = record
    T1, T2: Extended;
  end;

var
  UsedRed, UsedBlue: set of Byte;
  BlockI, BlockN, I, N: Longint;
  ARed, ABlue: array [1..2500] of TPoint;
  Res: array [1..2500] of TConection;

function Length(X1, Y1, X2, Y2: Extended): Extended; overload;
begin
  Length := Sqrt((X2 - X1)*(X2 - X1)+(Y2 - Y1)*(Y2 - Y1));
end;

function Length(A, B: TPoint): Extended; overload;
begin
  Length := Sqrt((B.X - A.X)*(B.X - A.X)+(B.Y - A.Y)*(B.Y - A.Y));
end;

function GetDist(X, Y, X1, Y1, X2, Y2: Extended): Extended; overload;
var
  p, L1, L2, L3, Sq: Extended;      
begin
  L1 := Length(X, Y, X1, Y1);
  L2 := Length(X, Y, X2, Y2);
  L3 := Length(X1, Y1, X2, Y2);
  p := (L1 + L2 + L3) / 2;
  Sq := Sqrt(p * (p - L1) * (p - L2) * (p - L3));

  GetDist := 2 * Sq / L1;
end;

function GetDist(P, P1, P2: TPoint): Extended; overload;
begin
  GetDist := GetDist(P.X, P.Y, P1.X, P1.Y, P2.X, P2.Y);
end;

function Check(const A1, A2, B1, B2: TPoint): Boolean;
function CheckT(const A1, A2, B1, B2: TPoint): Boolean;
var
  a01, b01, c01, a02, b02, c02, a, b, c: Extended;
begin
  a01 := Length(A1, B1);
  b01 := GetDist(B1, A1, A2);
  c01 := sqrt((a01 - b01) * (a01 + b01));

  a02 := Length(A1, B2);
  b02 := GetDist(B2, A1, A2);
  c02 := sqrt((a02 - b02) * (a02 + b02));

  a := Length(B1, B2);
  b := b01 - b02;
  c := c02 - c01;

  CheckT := b*b+c*c = a*a;
end;

begin
  Check := CheckT(A1, A2, B1, B2) or CheckT(B1, B2, A1, A2);
end;

procedure Get;
begin
  for I := 1 to N do
    Writeln(I, ' ', I);
end;

begin
  Assign(Input, 'PAIRS.DAT');
  Assign(Output, 'PAIRS.SOL');
  Reset(Input);
  Rewrite(Output);

  {ARed[1].X := 0;
  ARed[1].Y := 0;
  ABlue[1].X := 1;
  ABlue[1].Y := 0;
  ARed[2].X := 1;
  ARed[2].Y := 1;
  ABlue[2].X := 0;
  ABlue[2].Y := 1;}

{  Writeln(Check(ARed[1], ABlue[1], ARed[2], ABlue[2]));
  Readln;}

  Read(BlockN);
  for BlockI := 1 to BlockN do
    begin
      Read(N);
      if N = 1 then
        begin
          Read(ARed[1].X, ARed[1].Y);
          Writeln('1 1');
          Continue;
        end;

      for I := 1 to N do Read(ARed[I].X, ARed[I].Y);
      for I := 1 to N do Read(ABlue[I].X, ABlue[I].Y);
      Get;
//      for I := 1 to N do Writeln(Res[I].T1, ' ', Res[I].T2);
    end;

  Close(Input);
  Close(Output);
end.
