#ifndef _DEBUG
	#define __OPTIMIZE__ 3
#endif

#include <cstdlib>
#include <cstdio>
#include <cstring>
#include <cmath>
#include <iostream>
#include <string>
#include <list>
#include <vector>
#include <stack>
#include <queue>
using namespace std;
const double  pi=3.14159265358979323;
#define cX 0
#define cY 1
#define cP 2
#define cT 3
#define cN 4
#define cSize 5

int radial(const void *l,const void *r){
	int *x=*(int**)l,*y=*(int**)r;	
	double al=atan2l(x[1],x[0]),ar=atan2l(y[1],y[0]);
	int l2=x[0]*x[0]+x[1]*x[1],r2=y[0]*y[0]+y[1]*y[1];
	if (al==ar) return l2-r2;
	return (al<ar)?-1:1;
}
bool ise3(int *p1,int *p2,int **V){
	double x;
	if (p1[2]==0 && p2[2]==0) return true;
	if (p1[3]==0 && p2[3]==0) return true;
	if (p1[2]==0 && p2[2]==1) {
		x=-p2[4];
		if (abs(V[p1[0]][0]-V[p1[1]][0])==abs(V[p1[0]][0]-x)+abs(V[p1[1]][0]-x)) return true;
		else return false;
	}
	if (p1[2]==1 && p2[2]==0) {
		x=-p1[4];
		if (abs(V[p2[0]][0]-V[p2[1]][0])==abs(V[p2[0]][0]-x)+abs(V[p2[1]][0]-x)) return true;
		else return false;
	}
	if (p1[2]*p2[3]==p1[3]*p2[2]) return false;
	int A1=p1[2]*p2[3],C1=p1[4]*p2[3];
	int A2=p2[2]*p1[3],C2=p2[4]*p1[3];
	x=(double)(C1-C2)/(A1-A2);
	if (abs(V[p2[0]][0]-V[p2[1]][0])==abs(V[p2[0]][0]-x)+abs(V[p2[1]][0]-x)) return true;
	return false;
}
bool Interse3(int **Pairs,int p,int **V){
	--p;
	for (int i=0; i<p; ++i)
		if (ise3(Pairs[p],Pairs[i],V)) return true;
	return false;
}
int main(){
#ifdef _DEBUG
	freopen("input.txt","r",stdin);
#else 
	freopen("pairs.dat","r",stdin);
	freopen("pairs.sol","w",stdout);
#endif
	int T,x=0,y=0,N;
	cin>>T;
	while (T--){
		x=0; y=0;
		cin>>N;
		int **V=new int*[N<<1];
		int **P=new int*[N],p=0;		
		bool may=true;
		for (int i=0; i<2*N; i++){
			V[i]=new int[cSize];
			cin>>V[i][0]>>V[i][1]; V[i][2]=-1;
			V[i][3]=int(i>=N);
			V[i][4]=i%N+1;
			x+=V[i][0];
			y+=V[i][1];			
		}
		x/=2*N; /// 
		y/=2*N;
		for (int i=0; i<2*N; i++){
			V[i][0]-=x; V[i][1]-=y; ///³ 
		}
		qsort(V,N<<1,sizeof(int*),radial); ///   (    0,0)
		double t=atan2l(V[0][1],V[0][0]);
		try{
			for (int i=0; i<2*N; i++){
				if (V[i][2]==-1){
					for (int j=i+1; j<=2*N; j++){
						if (V[j%(2*N)][2]==-1 && V[j%(2*N)][3]!=V[i][3]){
							V[i][2]=p; V[j%(2*N)][2]=p;						
							P[p]=new int[5];
							P[p][0]=i; P[p][1]=j%(2*N);
							if (V[i][0]==V[j%(2*N)][0]){
								P[p][2]=1; P[p][3]=0; P[p][4]=-V[i][0];								
							} else  if (V[i][1]==V[j%(2*N)][1]){
								P[p][2]=0; P[p][3]=1; P[p][4]=-V[i][1];
							} else {
								P[p][2]=abs(V[i][0]-V[j%(2*N)][0]); P[p][3]=abs(V[i][1]-V[j%(2*N)][1]); P[p][4]=-P[p][2]*V[i][0]-P[p][3]*V[i][1];
							}							
							p++;
							if (Interse3(P,p,V)) throw false;						
							break;
						}
					}
				}
			}			
		}
		catch (bool e){
			may=e;
		}
		if (may){
			for (int i=0; i<p; i++){
				x=P[i][0]; y=P[i][1];
				if (V[x][3]==0) cout<<V[x][4]<<' '<<V[y][4]<<'\n';
				else cout<<V[y][4]<<' '<<V[x][4]<<'\n';
			}
		} else cout<<0<<'\n';		
		delete []P;		
		delete []V;
	}
	return 0;
}